config/routes.rb
Rails.application.routes.draw do
  resources :operational_systems
  resources :tools
  resources :projects
  resources :languages
  
  get "/users/login" => "login#index"
  post "/users/login" => "login#create"
  get "/users/logout" => "login#logout"
  resources :users

  root :to => "login#index"

	get 'auth/:provider/callback', to: 'omni_auth_login#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'omni_auth_login#destroy'


end

app/models/user.rb
require "bcrypt"

class User < ActiveRecord::Base
	has_many :projects
	
	validates_presence_of :email, :name
	validates_presence_of :password,  :if => :password
	validates_uniqueness_of :email
	validates_length_of :password, minimum: 6, :if => :password
	validates_confirmation_of :password, :if => :password
	validates_acceptance_of :terms

	def password=(new_password)
		@password = new_password
		self.encrypted_password = BCrypt::Password.create(@password)
	end

	def password
		@password
	end

	def valid_password?(password_to_validate)
		BCrypt::Password.new(encrypted_password) == password_to_validate
	end




	#TODO: Refactor
	def self.find_or_create_with_omniauth(auth)
	    user = self.find_or_create_by(:provider => auth.provider,:uid => auth.uid)
	    user.assign_attributes({ name: user.name || auth.info.name, 
	    	email: user.email || auth.info.email || "#{auth.info.name}@flosscoach.com", 
	    	photo_url: user.photo_url || auth.info.image, 
	    	fb_token: auth.credentials.token,
	    	password: "abababbbb", password_confirmation: "abababbbb"})
	    user.save!
	    user
	end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :update, :destroy]
  skip_before_filter :verify_authenticity_token, only: [:update]


  # GET /users
  def index
    redirect_to user_path(current_user)
  end

  # GET /users/1
  def show

  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  def create
    @user = User.new(user_params)
    @user.photo_url ||= "/assets/avatar.jpeg"
    if @user.save
      UsuarioMailer.newuser(@user).deliver
      session[:user_id] = @user.id
      redirect_to projects_path
      #redirect_to @user
    else
      render :new
    end
  end

  # PATCH/PUT /users/1
  def update

    if @user.update_attributes(user_params)
      respond_to do |format|
        format.json { render :json => { :status => 'Ok', :message => 'Received'}, :status => 200 }
      end    
    else
      render :edit
    end
  end

  # DELETE /users/1
  def destroy
    @user.destroy
    redirect_to users_url, notice: 'User was successfully destroyed.'
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = current_user
    end

    # Only allow a trusted parameter "white list" through.
    def user_params
      params.require(:user).permit!
    end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<%= form_for(@user) do |f| %>
  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% @user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :email %><br>
    <%= f.text_field :email %>
  </div>
  <div class="field">
    <%= f.label :password %><br>
    <%= f.text_field :password %>
  </div>
  <div class="field">
    <%= f.label :password_confirmation %><br>
    <%= f.text_field :password_confirmation %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form' %>

<%= link_to 'Show', @user %> |
<%= link_to 'Back', users_path %>

app/views/users/index.html.erb
 <div class="page animsition page-profile">

    <div class="page-content container-fluid">
      <div class="row">
        <div class="col-md-3">
          <!-- Page Widget -->
          <div class="widget widget-shadow text-center">
            <div class="widget-header">
              <div class="widget-header-content">
                <a class="avatar avatar-lg" href="javascript:void(0)">
                  <%= image_tag("5.jpg", :alt => "...") %>
                </a>
                <h4 class="profile-user editable">
                  <span class='name' data-plugin="summernote" data-air-mode="true"><%= @user.name %></span>
                  <i class="icon wb-pencil" aria-hidden="true"></i>
                </h4>
                <p class="editable" >
                <span class='description' data-plugin="summernote" data-air-mode="true"> <%= @user.description.blank? ? "Insert a description" : @user.description %></span>
                                  <i class="icon wb-pencil" aria-hidden="true"></i></p>
                <div class="profile-social">
                  <a class="icon bd-twitter" href="#LINK-TWITTER"></a>
                  <a class="icon bd-facebook" href="#LINK-FACEBOOK"></a>
                  <a class="icon bd-github" href="#LINK-GITHUB"></a>
                </div>
              <!--  <button type="button" class="btn btn-primary">Follow</button> -->
              </div>
            </div>
            <div class="widget-footer">
              <div class="row no-space">
                <div class="col-xs-12">
                  <strong class="profile-stat-count"><%= @user.projects.size %></strong>
                  <span>Projects created</span>
                </div>

              </div>
            </div>
          </div>
          <!-- End Page Widget -->
        </div>
        <div class="col-md-9">
          <!-- Panel -->
          <div class="panel">
            <div class="panel-body nav-tabs-animate nav-tabs-horizontal">
              <ul class="nav nav-tabs nav-tabs-line" data-plugin="nav-tabs" role="tablist">
                <li class="active" role="presentation"><a data-toggle="tab" href="#recent-activities" aria-controls="recent-activities"
                  role="tab">Recent activities <span class="badge badge-danger">5</span></a></li>
                <li role="presentation"><a data-toggle="tab" href="#activities-your-projects" aria-controls="activities-your-projects" role="tab">Activities in your projects </a></li>
                <li role="presentation"><a data-toggle="tab" href="#your-projects" aria-controls="your-projects"
                  role="tab">Your projects </a></li>
                <li class="dropdown" role="presentation" style="display: none;">
                  <a class="dropdown-toggle" data-toggle="dropdown" href="#" aria-expanded="false">
                    <span class="caret"></span>Menu </a>
                  <ul class="dropdown-menu" role="menu">
                    <li role="presentation" style="display: none;"><a data-toggle="tab" href="#recent-activities" aria-controls="recent-activities"
                      role="tab">Recent activities <span class="badge label-danger">5</span></a></li>
                    <li role="presentation" style="display: none;"><a data-toggle="tab" href="#activities-your-projects" aria-controls="activities-your-projects"
                      role="tab">Activities in your projects</a></li>
                    <li role="presentation"><a data-toggle="tab" href="#your-projets" aria-controls="your-projects"
                      role="tab">Your projects</a></li>
                  </ul>
                </li>
              </ul>
              <div class="tab-content">
                <div class="tab-pane active animation-slide-left" id="recent-activities" role="tabpanel">
                  <ul class="list-group">
                    <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Você mesmo
                            <span>posted an updated</span>
                          </h4>
                          <small>14 minutes ago</small>
                          <div class="profile-brief">Commit in #98t90r809t80ew8t. Please check it.</div>
                        </div>
                      </div>
                    </li>

                    <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Seu irmão gêmeo
                            <span>posted an new activity comment</span>
                          </h4>
                          <small>active 14 minutes ago</small>
                          <div class="profile-brief">Cras sit amet nibh libero, in gravida nulla. Nulla vel
                            metus.</div>
                        </div>
                      </div>
                    </li>
       
                  </ul>
                  <a class="btn btn-block btn-default profile-readMore" href="javascript:void(0)"
                  role="button">Show more</a>
                </div>
                <div class="tab-pane animation-slide-left" id="activities-your-projects" role="tabpanel">
                  <ul class="list-group">
                     <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Você mesmo
                            <span>posted an updated</span>
                          </h4>
                          <small>14 minutes ago</small>
                          <div class="profile-brief">Commit in #98t90r809t80ew8t. Please check it.</div>
                        </div>
                      </div>
                    </li>

                    <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Seu irmão gêmeo
                            <span>posted an new activity comment</span>
                          </h4>
                          <small>active 14 minutes ago</small>
                          <div class="profile-brief">Cras sit amet nibh libero, in gravida nulla. Nulla vel
                            metus.</div>
                        </div>
                      </div>
                    </li>

                  </ul>
                </div>
                <div class="tab-pane animation-slide-left" id="your-projects" role="tabpanel">
                  <ul class="list-group">
                  <% if @user.projects %>
                       <% @user.projects.each do |project| %>
                        <%= link_to(project) do %>
                          <li class="list-group-item">
                            <div class="media">
                              <div class="media-left">
                                <div class="avatar avatar-online">
                                   <img src="<%= project.image_url %>" alt="<%= project.name %> image"/>
                                </div>
                              </div>
                              <div class="media-body">
                                <h4 class="media-heading">
                                  <%= project.name %>
                                </h4>
                                <p>
                                  <%= project.description %>
                                </p>
                              </div>
                            </div>
                          </li>
                        <% end %>
                      <% end %>
                  <% else %>
                <h4>Você não tem projetos cadastrados.</h4>

                <% end %>
        
                  </ul>
                </div>
              </div>
            </div>
          </div>
          <!-- End Panel -->
        </div>
      </div>
    </div>
  </div>

app/views/users/new.html.erb
<body class="page-register-v2 layout-full page-dark">
  <!--[if lt IE 8]>
        <p class="browserupgrade">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> to improve your experience.</p>
    <![endif]-->
  <!-- Page -->
  <div class="page animsition" data-animsition-in="fade-in" data-animsition-out="fade-out">
    <div class="page-content">
      <div class="page-brand-info">
        <div class="brand">
          <h2 class="brand-text font-size-40">FLOSS Coach</h2>
        </div>
        <p class="font-size-20">FLOSS Coach creators are researchers who want to help newcomers to Free/Libre Open Source Software (FLOSS)
		Have you ever thought about contributing to an Open Source Project? Have you tried? Was it too hard?</p>
      </div>

      <div class="page-register-main">
        <h3 class="font-size-24">Sign Up</h3>
        <p>Register NOW! Check our prototype and give us your feedback</p>

		<%= form_for(@user) do |f| %>
		  <% if @user.errors.any? %>
		  	<div class="summary-errors alert alert-danger alert-dismissible">
              <button type="button" class="close" aria-label="Close" data-dismiss="alert">
                <span aria-hidden="true">×</span>
              </button>
              <p><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</p>
              <ul>
	              <% @user.errors.full_messages.each do |message| %>
			        <li data-field="summary_fullName"><%= message %></li>
			      <% end %>
		      </ul>
        </div>
		  <% end %>

          <div class="form-group">
            <label class="sr-only" for="user_name">Full Name</label>
            <input type="text" class="form-control" id="user_name" name="user[name]" placeholder="Name">
          </div>
          <div class="form-group">
            <label class="sr-only" for="user_email">Email</label>
            <input type="email" class="form-control" id="user_email" name="user[email]" placeholder="Email">
          </div>
          <div class="form-group">
            <label class="sr-only" for="user_password">Password</label>
            <input type="password" class="form-control" id="user_password" name="user[password]" placeholder="Password">
          </div>
          <div class="form-group">
            <label class="sr-only" for="user_password_confirmation">Retype Password</label>
            <input type="password" class="form-control" id="user_password_confirmation" name="user[password_confirmation]" placeholder="Confirm Password">
          </div>
          <div class="form-group clearfix">
            <div class="checkbox-custom checkbox-inline checkbox-primary pull-left">
              <input name="user[terms]" type="hidden" value="0" />
              <input type="checkbox" value="1" name="user[terms]" id="user_terms" />
              <label for="user_terms"></label>
            </div>
            <p class="margin-left-40">By clicking Sign Up, you agree to our <a href="#">Terms</a>.</p>
          </div>
          <%= f.submit 'Sign Up', class: 'btn btn-primary btn-block' %>

		<% end %>

        <p>Have account already? Please go to <%= link_to 'Sign In', users_login_path %></p>

      </div>
    </div>
  </div>

app/views/users/show.html.erb
 <div class="page animsition page-profile">

    <div class="page-content container-fluid">
      <div class="row">
        <div class="col-md-3">
          <!-- Page Widget -->
          <div class="widget widget-shadow text-center">
            <div class="widget-header">
              <div class="widget-header-content">
                <a class="avatar avatar-lg" href="javascript:void(0)">
                  <img src="<%= current_user.photo_url %>" />
                </a>
                <h4 class="profile-user editable">
                  <span class='name' data-plugin="summernote" data-air-mode="true"><%= @user.name %></span>
                  <i class="icon wb-pencil" aria-hidden="true"></i>
                </h4>
                <p class="editable" >
                <span class='description' data-plugin="summernote" data-air-mode="true"> <%= @user.description.blank? ? "Insert a description" : @user.description %></span>
                                  <i class="icon wb-pencil" aria-hidden="true"></i></p>
                <div class="profile-social">
                  <a class="icon bd-twitter" href="#LINK-TWITTER"></a>
                  <a class="icon bd-facebook" href="#LINK-FACEBOOK"></a>
                  <a class="icon bd-github" href="#LINK-GITHUB"></a>
                </div>
              <!--  <button type="button" class="btn btn-primary">Follow</button> -->
              </div>
            </div>
            <div class="widget-footer">
              <div class="row no-space">
                <div class="col-xs-12">
                  <strong class="profile-stat-count"><%= @user.projects.size %></strong>
                  <span>Projects created</span>
                </div>

              </div>
            </div>
          </div>
          <!-- End Page Widget -->
        </div>
        <div class="col-md-9">
          <!-- Panel -->
          <div class="panel">
            <div class="panel-body nav-tabs-animate nav-tabs-horizontal">
              <ul class="nav nav-tabs nav-tabs-line" data-plugin="nav-tabs" role="tablist">
                <li class="active" role="presentation"><a data-toggle="tab" href="#recent-activities" aria-controls="recent-activities"
                  role="tab">Recent activities <span class="badge badge-danger">5</span></a></li>
                <li role="presentation"><a data-toggle="tab" href="#activities-your-projects" aria-controls="activities-your-projects" role="tab">Activities in your projects </a></li>
                <li role="presentation"><a data-toggle="tab" href="#your-projects" aria-controls="your-projects"
                  role="tab">Your projects </a></li>
                <li class="dropdown" role="presentation" style="display: none;">
                  <a class="dropdown-toggle" data-toggle="dropdown" href="#" aria-expanded="false">
                    <span class="caret"></span>Menu </a>
                  <ul class="dropdown-menu" role="menu">
                    <li role="presentation" style="display: none;"><a data-toggle="tab" href="#recent-activities" aria-controls="recent-activities"
                      role="tab">Recent activities <span class="badge label-danger">5</span></a></li>
                    <li role="presentation" style="display: none;"><a data-toggle="tab" href="#activities-your-projects" aria-controls="activities-your-projects"
                      role="tab">Activities in your projects</a></li>
                    <li role="presentation"><a data-toggle="tab" href="#your-projets" aria-controls="your-projects"
                      role="tab">Your projects</a></li>
                  </ul>
                </li>
              </ul>
              <div class="tab-content">
                <div class="tab-pane active animation-slide-left" id="recent-activities" role="tabpanel">
                  <ul class="list-group">
                    <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Você mesmo
                            <span>posted an updated</span>
                          </h4>
                          <small>14 minutes ago</small>
                          <div class="profile-brief">Commit in #98t90r809t80ew8t. Please check it.</div>
                        </div>
                      </div>
                    </li>

                    <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Seu irmão gêmeo
                            <span>posted an new activity comment</span>
                          </h4>
                          <small>active 14 minutes ago</small>
                          <div class="profile-brief">Cras sit amet nibh libero, in gravida nulla. Nulla vel
                            metus.</div>
                        </div>
                      </div>
                    </li>
       
                  </ul>
                  <a class="btn btn-block btn-default profile-readMore" href="javascript:void(0)"
                  role="button">Show more</a>
                </div>
                <div class="tab-pane animation-slide-left" id="activities-your-projects" role="tabpanel">
                  <ul class="list-group">
                     <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Você mesmo
                            <span>posted an updated</span>
                          </h4>
                          <small>14 minutes ago</small>
                          <div class="profile-brief">Commit in #98t90r809t80ew8t. Please check it.</div>
                        </div>
                      </div>
                    </li>

                    <li class="list-group-item">
                      <div class="media">
                        <div class="media-left">
                          <a class="avatar" href="javascript:void(0)">
                            <%= image_tag("5.jpg", :alt => "...", :class => "img-responsive") %>
                          </a>
                        </div>
                        <div class="media-body">
                          <h4 class="media-heading">Seu irmão gêmeo
                            <span>posted an new activity comment</span>
                          </h4>
                          <small>active 14 minutes ago</small>
                          <div class="profile-brief">Cras sit amet nibh libero, in gravida nulla. Nulla vel
                            metus.</div>
                        </div>
                      </div>
                    </li>

                  </ul>
                </div>
                <div class="tab-pane animation-slide-left" id="your-projects" role="tabpanel">
                  <ul class="list-group">
                  <% if @user.projects %>
                       <% @user.projects.each do |project| %>
                        <%= link_to(project) do %>
                          <li class="list-group-item">
                            <div class="media">
                              <div class="media-left">
                                <div class="avatar avatar-online">
                                  <img src="https://www.mozilla.org/media/img/firefox/firefox-256.e2c1fc556816.jpg" alt="...">
                                </div>
                              </div>
                              <div class="media-body">
                                <h4 class="media-heading">
                                  <%= project.name %>
                                </h4>
                                <p>
                                  <%= project.description %>
                                </p>
                              </div>
                            </div>
                          </li>
                        <% end %>
                      <% end %>
                  <% else %>
                <h4>Você não tem projetos cadastrados.</h4>

                <% end %>
        
                  </ul>
                </div>
              </div>
            </div>
          </div>
          <!-- End Panel -->
        </div>
      </div>
    </div>
  </div>